#include "StdAfx.h"
#include ".\sampa.h"
#include ".\TransList.h"
#include ".\Trans.h"
#include ".\Brake.h"

using namespace std;

CSAMPA::CSAMPA(void)
: m_strLine("")
{	
}

CSAMPA::CSAMPA(CString strLine)
: m_strLine(strLine)
{
	CTrans *pTrans;	
	m_strLine.MakeLower();	
	Numbers();	
	for(int i=0; i<m_strLine.GetLength(); i++)
	{					
		pTrans = new CTrans(char((int)m_strLine[i]), 80);
		m_trLine.AddTail((CObject*)pTrans);
	}
	
	Reduction();
	ConvertA();
	Wyrazy();
	DoubleLetters();
	SetDuration();
	SetFrequencyWord();
	SetFrequencySentence();
}

CSAMPA::~CSAMPA(void)
{
	POSITION pos = m_trLine.GetHeadPosition();
	CTransList *ptrList;
	while(pos != NULL)
	{
		ptrList = (CTransList*)m_trLine.GetNext(pos);
		ptrList->DeleteAll();
	}
	m_trLine.RemoveAll();
	delete ptrList;
}

void CSAMPA::SetLine(CString strLine)
{
	this->m_strLine = strLine;
}

CString CSAMPA::GetLine(void)
{
	return this->m_strLine;	
}

void CSAMPA::Display(void)
{
	POSITION pos = m_trLine.GetHeadPosition();
	POSITION pos_2 = NULL;
	CTransList *ptrWyraz = new CTransList();
	CTransList *ptrSylaba = new CTransList();
	cout << "WORDS: " << (int)m_trLine.GetCount() << endl;
	cout << "_ 50" << endl;
	while(pos != NULL)
	{
		ptrWyraz = (CTransList*)m_trLine.GetNext(pos);
		pos_2 = ptrWyraz->GetHeadPosition();
		while(pos_2 != NULL)
		{			
			ptrSylaba = (CTransList*)ptrWyraz->GetNext(pos_2);
			ptrSylaba->Display();
			cout << "...................." << endl;
		}		
		cout << "-----------" << endl;
	}
	ptrWyraz = (CTransList*)m_trLine.GetTail();
	ptrSylaba = (CTransList*)ptrWyraz->GetTail();
	CTrans *pTrans = (CTrans*)ptrSylaba->GetTail();
	if(pTrans->GetLetter()[0] != '_')
		cout << "_ 50" << endl;
}

void CSAMPA::Write(void)
{
	POSITION pos = m_trLine.GetHeadPosition();
	POSITION pos_2 = NULL;
	CTransList *ptrWyraz = new CTransList();
	CTransList *ptrSylaba = new CTransList();
	ofstream fout;
	fout.open("synteza.pho");	
	fout << "_ 50" << "\n";
	fout.flush();
	fout.close();
	for(int i=0; i<m_trLine.GetCount(); i++)
	{
		ptrWyraz = m_trLine.GetSylaba(i);
		for(int j=0; j<ptrWyraz->GetCount(); j++)
		{			
			ptrSylaba = ptrWyraz->GetSylaba(j);
			ptrSylaba->Write();
		}
	}
	ptrWyraz = m_trLine.GetSylaba((int)m_trLine.GetCount()-1);
	ptrSylaba = ptrWyraz->GetSylaba((int)ptrWyraz->GetCount()-1);
	CTrans *pTrans = ptrSylaba->GetLetter((int)ptrSylaba->GetCount()-1);
	if(pTrans->GetLetter()[0] != '_')
	{
		fout.open("synteza.pho", ios::app);
		fout << "_ 50" << "\n";
		fout.flush();
		fout.close();
	}
	cout << "WRITE FINISHED" << endl;
}

int CSAMPA::Check(int nIndex, CString strLetter)
{
	if(nIndex < m_strLine.GetLength() && nIndex >= 0)
	{
		CString strTmp = (CString)m_strLine[nIndex];		
		if(strTmp.CompareNoCase(strLetter) == 0)
			return 1;
		else
			return 0;
	}
	else
		return -1;
}

int CSAMPA::CheckUbez(int nIndex)
{
	if(nIndex < m_strLine.GetLength() && nIndex >= 0)
	{
		switch(m_strLine[nIndex])
		{
		case 'p':
		case 't':
		case 'k':		
		case 'c':
		case 'f':
		case 's':			
			return 1;
			break;
		case ' ':			
			if(nIndex+1 < m_strLine.GetLength())
			{
				switch(m_strLine[nIndex+1])
				{
					case 'p':
					case 't':
					case 'k':		
					case 'c':
					case 'f':
					case 's':			
						return 1;
						break;
					default:
						return 0;
						break;
				};
			}
			else
				return 0;
			break;
		default:
			return 0;
			break;
		};
	}
	else
		return -1;
}

int CSAMPA::CheckUdz(int nIndex)
{
	if(nIndex < m_strLine.GetLength() && nIndex >= 0)
	{
		switch(m_strLine[nIndex])
		{
		case 'b':
		case 'd':
		case 'g':
		case 'w':
		case 'z':
		case char(190):
			return 1;
			break;
		case ' ':
			if(nIndex+1 < m_strLine.GetLength())
			{
				switch(m_strLine[nIndex+1])
				{
					case 'b':
					case 'd':
					case 'g':
					case 'w':
					case 'z':
					case char(190):
						return 1;
						break;
					default:
						return 0;
						break;
				};
			}
			else
				return 0;
			break;
		default:
			return 0;
			break;
		};
	}
	else
		return -1;
}

int CSAMPA::CheckSamogl(int nIndex)
{
	if(nIndex < m_strLine.GetLength() && nIndex >= 0)
	{
		switch(m_strLine[nIndex])
		{
		case 'i':
		case 'y':
		case 'e':
		case 'a':
		case 'o':
		case 'u':
		case '':
		case char(169):
			return 1;
			break;
		case ' ':
			if(nIndex+1 < m_strLine.GetLength())
			{
				switch(m_strLine[nIndex+1])
				{
					case 'i':
					case 'y':
					case 'e':
					case 'a':
					case 'o':
					case 'u':
					case '':
					case char(169):
						return 1;
						break;
					default:
						return 0;
						break;
				};
			}
			else
				return 0;
			break;
		default:
			return 0;
			break;
		};
	}
	else
		return -1;
}

int CSAMPA::CheckZwarte(int nIndex)
{
	if(nIndex < m_strLine.GetLength() && nIndex >= 0)
	{
		switch(m_strLine[nIndex])
		{
		case 'p':
		case 'b':
		case 't':
		case 'g':
		case 'k':
            return 1;
			break;
		default:
			return 0;
			break;
		};
	}
	else
		return -1;
}

int CSAMPA::LookFor(CString strWord)
{	
	CString strToken;	
	int nCurPos = 0;
	int nRetValue = 0;
	strToken= m_strLine.Tokenize(" ",nCurPos);	
	while(strToken != "")
	{
		if(strToken == strWord)
		{
			nRetValue = 1;
			break;
		}
		strToken= m_strLine.Tokenize(" ",nCurPos);
	};
	return nRetValue;
}

void CSAMPA::Numbers(void)
{
	cout << "NUMBERS" << endl;	
	CString strTmp;
	for(int i=0; i<m_strLine.GetLength(); i++)
	{		
		switch(m_strLine[i])
		{
		case '1':
			m_strLine.Delete(i, 1);
			m_strLine.Insert(i, " jeden ");
			break;
		case '2':
			m_strLine.Delete(i, 1);
			m_strLine.Insert(i, " dwa ");
			break;
		case '3':
			m_strLine.Delete(i, 1);
			m_strLine.Insert(i, " trzy ");
			break;
		case '4':
			m_strLine.Delete(i, 1);
			m_strLine.Insert(i, " cztery ");
			break;
		case '5':	
			m_strLine.Delete(i, 1);
			strTmp = " pi";
			strTmp.AppendChar(char(169));
			strTmp.AppendChar(char(134));
			strTmp += " ";
			m_strLine.Insert(i, strTmp);			
			break;
		case '6':
			m_strLine.Delete(i, 1);
			strTmp = " sze";
			strTmp.AppendChar(char(152));
			strTmp.AppendChar(char(134));
			strTmp += " ";
			m_strLine.Insert(i, strTmp);
			break;
		case '7':
			m_strLine.Delete(i, 1);
			m_strLine.Insert(i, " siedem ");
			break;
		case '8':
			m_strLine.Delete(i, 1);
			m_strLine.Insert(i, " osiem ");
			break;
		case '9':
			m_strLine.Delete(i, 1);
			strTmp = " dziewi";
			strTmp.AppendChar(char(169));
			strTmp.AppendChar(char(134));
			strTmp += " ";
			m_strLine.Insert(i, strTmp);
			break;
		case '0':
			m_strLine.Delete(i, 1);
			m_strLine.Insert(i, " zero ");
			break;		
		};
	}	
}

void CSAMPA::ConvertA(void)
{
	CTrans *pTrans;
	CTransList m_trTmp;
	for(int i=0; i<m_strLine.GetLength(); i++)
	{		
		switch(m_strLine[i])
		{
		case 'u':
		case char(162):
			pTrans = m_trLine.GetLetter(i);	
			pTrans->SetLetter("u");
			m_trTmp.AddTail((CObject*)pTrans);
			break;
		case 'y':
			pTrans = m_trLine.GetLetter(i);	
			pTrans->SetLetter("I");
			m_trTmp.AddTail((CObject*)pTrans);
			break;	
		case char(136):
			pTrans = m_trLine.GetLetter(i);
			pTrans->SetLetter("w");
			m_trTmp.AddTail((CObject*)pTrans);
			break;
		case 'w':
			pTrans = m_trLine.GetLetter(i);
			if((this->Check(i+1, " ") == 1 ||
				i+1 == m_strLine.GetLength() ||
				this->CheckUbez(i+1) == 1 ||
				this->CheckUbez(i-1) == 1 ||
				this->Check(i+1, ".") == 1 ||
				this->Check(i+1, "?") == 1 ||
				this->Check(i+1, "!") == 1) && this->Check(i-1, " ") != 1)
			{				
				pTrans->SetLetter("f");			
			}
			else
			{				
				pTrans->SetLetter("v");			
			}
			m_trTmp.AddTail((CObject*)pTrans);
			break;
		case 'h':
			if(this->Check(i-1, "c") != 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("x");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
		case char(190):
			pTrans = m_trLine.GetLetter(i);
			// na koncu wyrazu, wyglos, przed spolgloska bezdzwieczna
			if(this->Check(i+1, " ") == 1 ||
				i+1 == m_strLine.GetLength() ||
				this->CheckUbez(i+1) == 1)
			{				
				pTrans->SetLetter("S");		
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// kazdy inny przypadek
			else
			{				
				pTrans->SetLetter("Z");			
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
		case 'r':
			// rz
			if(this->Check(i+1, "z") == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				// na koncu wyrazu, przed spolgloska bezdzwiczna
				if(this->Check(i+2, " ") == 1 ||
					i+2 == m_strLine.GetLength() ||
					this->CheckUbez(i+2) == 1 ||
					this->CheckUbez(i-1) == 1)
				{					
					pTrans->SetLetter("S");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				// kazdy inny przypadek
				else
				{				
					pTrans->SetLetter("Z");
					m_trTmp.AddTail((CObject*)pTrans);
				}
			}
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
		case 'i':
			if(this->CheckSamogl(i+1) == 1)
			{
				if(this->CheckZwarte(i-1) == 1 ||
					this->Check(i-1, "m") == 1 ||
					this->Check(i-1, "f") == 1 ||
					this->Check(i-1, "w") == 1 ||
					this->Check(i-1, "h") == 1 ||
					this->Check(i-1, "l") == 1 ||
					this->Check(i-1, "r") == 1)
				{
					pTrans = m_trLine.GetLetter(i);
					pTrans->SetLetter("j");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				else
				{
					if(this->Check(i-1, "z") != 1 &&
					this->Check(i-1, "c") != 1 &&
					this->Check(i-1, "s") != 1 &&
					this->Check(i-1, "n") != 1)
					{
						pTrans = m_trLine.GetLetter(i);
						m_trTmp.AddTail((CObject*)pTrans);
					}
				}
			}
			else if(this->Check(i+1, "i") == 1)
			{
				if(this->CheckZwarte(i-1) == 1 ||
					this->Check(i-1, "m") == 1 ||
					this->Check(i-1, "f") == 1 ||
					this->Check(i-1, "w") == 1 ||
					(this->Check(i-1, "h") == 1 &&
					this->Check(i-2, "c") == 1) ||
					this->Check(i-1, "l") == 1 ||
					this->Check(i-1, "r") == 1)
				{
					pTrans = m_trLine.GetLetter(i);
					pTrans->SetLetter("ji");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				else
				{
					if(this->Check(i-1, "z") != 1 &&
					this->Check(i-1, "c") != 1 &&
					this->Check(i-1, "s") != 1 &&
					this->Check(i-1, "n") != 1)
					{
						pTrans = m_trLine.GetLetter(i);
						m_trTmp.AddTail((CObject*)pTrans);
					}
				}
			}
			else
			{
				if(this->Check(i-1, "z") != 1 &&
					this->Check(i-1, "c") != 1 &&
					this->Check(i-1, "s") != 1 &&
					this->Check(i-1, "n") != 1)
				{
					pTrans = m_trLine.GetLetter(i);
					m_trTmp.AddTail((CObject*)pTrans);
				}
			}
			break;
		case 's':
			// si
			if(this->Check(i+1, "i") == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				if(this->CheckUdz(i+2) == 1 &&
					i != 0)// && this->Check(i-1, " ") != 1)
				{					
					pTrans->SetLetter("z'");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				else
				{				
					pTrans->SetLetter("s'");
					m_trTmp.AddTail((CObject*)pTrans);
				}								
			}
			// sz
			else if(this->Check(i+1, "z") == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				if(this->CheckUdz(i+2) == 1 &&
					i != 0 )//&& this->Check(i-1, " ") != 1)
				{
					pTrans->SetLetter("Z");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				else
				{
					pTrans->SetLetter("S");
					m_trTmp.AddTail((CObject*)pTrans);
				}								
			}
			else
			{
				if(this->CheckUdz(i+1) == 1 &&
					i != 0 )//&& this->Check(i-1, " ") != 1)
				{
					pTrans = m_trLine.GetLetter(i);
					pTrans->SetLetter("z");					
					m_trTmp.AddTail((CObject*)pTrans);
				}
				else
				{
					pTrans = m_trLine.GetLetter(i);
					m_trTmp.AddTail((CObject*)pTrans);
				}
			}			
			break;
			// 
		case _T(char(152)):
				pTrans = m_trLine.GetLetter(i);
				if(this->CheckUdz(i+1) == 1)// &&
//					i != 0 )//&& this->Check(i-1, " ") != 1)
				{
					pTrans->SetLetter("z'");
				}
				else
				{				
					pTrans->SetLetter("s'");
				}			
				m_trTmp.AddTail((CObject*)pTrans);
			break;
		case 'z':
			// zi			
			if(this->Check(i-1, "s") != 1 &&
				this->Check(i-1, "c") != 1 &&
				this->Check(i-1, "d") != 1)
			{
				if(this->Check(i+1, "i") == 1)
				{
					pTrans = m_trLine.GetLetter(i);
					// koniec wyrazu, wyglos, przed spolgloska bezdzwieczna
					if(this->Check(i+2, " ") == 1 ||
						i+2 == m_strLine.GetLength() ||
						this->CheckUbez(i+2) == 1)
					{					
						pTrans->SetLetter("s'");
					}
					// kazdy inny przypadek
					else
					{				
						pTrans->SetLetter("z'");
					}
					m_trTmp.AddTail((CObject*)pTrans);
				}
				// koniec wyrazu, wyglos, przed spolgloska bezdzwieczna						
				else if(this->Check(i+1, " ") == 1 ||
					i+1 == m_strLine.GetLength() ||
					this->CheckUbez(i+1) == 1)
				{
					pTrans = m_trLine.GetLetter(i);
					pTrans->SetLetter("s");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				else
				{
						pTrans = m_trLine.GetLetter(i);
						m_trTmp.AddTail((CObject*)pTrans);			
				}
			}						
			break;
			// 
		case char(171):
			pTrans = m_trLine.GetLetter(i);
			// koniec wyrazu, wyglos, przed spolgloska bezdzwieczna
			if(this->Check(i+1, " ") == 1 || 
				i+1 == m_strLine.GetLength() ||
				this->CheckUbez(i+1) == 1)
			{				
				pTrans->SetLetter("s'");
			}
			// kazdy inny przypadek
			else
			{			
				pTrans->SetLetter("z'");			
			}
			//m_trLine.InsertAt(i, pTrans);
			m_trTmp.AddTail((CObject*)pTrans);
			break;
		case 'n':	
			// ni
			if(this->Check(i+1, "i") == 1)
			{	
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("n'");
				m_trTmp.AddTail((CObject*)pTrans);				
			}
			// n przed k, g
			else if((this->Check(i+1, "k") == 1) ||
				(this->Check(i+1, "g") == 1))
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("N");		
				m_trTmp.AddTail((CObject*)pTrans);
			}	
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
			// 
		case char(228):
			pTrans = m_trLine.GetLetter(i);
			pTrans->SetLetter("n'");
			m_trTmp.AddTail((CObject*)pTrans);
			break;
		case 'c':
			// ci
			if(this->Check(i+1, "i") == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				if(this->CheckUdz(i+2) == 1 &&
					i != 0 && this->Check(i-1, " ") != 1)
				{					
					pTrans->SetLetter("dz'");
				}
				else
				{				
					pTrans->SetLetter("ts'");
				}
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// cz
			else if(this->Check(i+1, "z") == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				if(this->CheckUdz(i+2) == 1 &&
					i != 0 && this->Check(i-1, " ") != 1)
				{					
					pTrans->SetLetter("dZ");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				else
				{				
					pTrans->SetLetter("tS");		
					m_trTmp.AddTail((CObject*)pTrans);
				}
			} 
			// ch
			else if(this->Check(i+1, "h") == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("x");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// c
			else
			{
				pTrans = m_trLine.GetLetter(i);
				if(this->CheckUdz(i+1) == 1 &&
					i != 0 && this->Check(i-1, " ") != 1)
				{					
					pTrans->SetLetter("dz");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				else
				{					
					pTrans->SetLetter("ts");		
					m_trTmp.AddTail((CObject*)pTrans);
				}
			}
			break;
			// 
		case char(134):
			pTrans = m_trLine.GetLetter(i);
			pTrans->SetLetter("ts'");
			m_trLine.InsertAt(i, pTrans);
			m_trTmp.AddTail((CObject*)pTrans);
			break;
		case 'd':
			// dz
			if(this->Check(i+1, "z") == 1)
			{
				// dzi
				if(this->Check(i+2, "i") == 1)
				{
					pTrans = m_trLine.GetLetter(i);
					if(this->Check(i+3, " ") == 1 ||
						i+3 == m_strLine.GetLength())
					{						
						pTrans->SetLetter("ts'");						
					}
					else
					{						
						pTrans->SetLetter("dz'");										
					}					
					m_trTmp.AddTail((CObject*)pTrans);
				}
				// dz wygLos, koniec tekstu
				else if(this->Check(i+2, " ") == 1 ||
					i+1 == m_strLine.GetLength() ||
					this->CheckUbez(i+2) == 1)
				{
					pTrans = m_trLine.GetLetter(i);
					pTrans->SetLetter("ts");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				//dz w innym przypadku
				else
				{
					pTrans = m_trLine.GetLetter(i);
					pTrans->SetLetter("dz");
					m_trTmp.AddTail((CObject*)pTrans);
				}
			}
			// d
			else if(this->Check(i+1, CString(char(171))) == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				if(this->Check(i+2, " ") == 1 ||
					i+2 == m_strLine.GetLength() ||
					this->CheckUbez(i+2) == 1)
				{					
					pTrans->SetLetter("ts'");					
				}
				else
				{					
					pTrans->SetLetter("dz'");				
				}				
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// d
			else if(this->Check(i+1, CString(char(190))) == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				if(this->Check(i+2, " ") == 1 ||
					i+2 == m_strLine.GetLength() ||
					this->CheckUbez(i+2) == 1)
				{					
					pTrans->SetLetter("tS");
				}
				else
				{				
					pTrans->SetLetter("dZ");				
				}				
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// d wygLos, koniec wyrazu
			else if(this->Check(i+1, " ") == 1 || 
				i+1 == m_strLine.GetLength() ||
				this->CheckUbez(i+1) == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("t");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
		// 
		case char(169):
			pTrans = m_trLine.GetLetter(i);
			// koniec wyrazu, wygLos
			if(this->Check(i+1, ".") == 1 ||
				this->Check(i+1, "?") == 1 ||
				this->Check(i+1, "!") == 1 || 
				i+1 == m_strLine.GetLength())
			{				
				pTrans->SetLetter("e~");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// przed p, b
			else if(this->Check(i+1, "p") == 1 || 
				this->Check(i+1, "b") == 1)
			{
				pTrans->SetLetter("em");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// przed k, g
			else if(this->Check(i+1, "k") == 1 ||
				this->Check(i+1, "g") == 1)
			{
				pTrans->SetLetter("eN");
				//m_trLine.InsertAt(i, pTrans);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// przed l
			else if(this->Check(i+1, "l") == 1)
			{
				pTrans->SetLetter("e");
				//m_trLine.InsertAt(i, pTrans);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// przed 
			else if(this->Check(i+1, CString(char(136))) == 1)
			{
				pTrans->SetLetter("e");
				//m_trLine.InsertAt(i, pTrans);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			// przed 
			else if(this->Check(i+1, CString(char(134))) == 1)
			{
				pTrans->SetLetter("en'");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			else if(this->Check(i+1, "c") == 1 )
			{
				// przed ci
				if(this->Check(i+2, "i") == 1)
				{
					pTrans->SetLetter("en'");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				// przed c
				else
				{
					pTrans->SetLetter("en");
					m_trTmp.AddTail((CObject*)pTrans);
				}				
			}
			else if(this->Check(i+1, "d") == 1)
			{
				// przed d
				if(this->Check(i+2, CString(char(171))) == 1)
				{
					pTrans->SetLetter("en'");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				// przed dzi
				else if(this->Check(i+2, "z") == 1 &&
					this->Check(i+3, "i") == 1)
				{
					pTrans->SetLetter("en'");
					m_trTmp.AddTail((CObject*)pTrans);
				}
				// przed d
				else
				{
					pTrans->SetLetter("en");		
					m_trTmp.AddTail((CObject*)pTrans);
				}				
			}
			else if(this->Check(i+1, "t") == 1)
			{
				pTrans->SetLetter("en");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;	
		case char(185):			
			pTrans = m_trLine.GetLetter(i);
			// wygLos, koniec wyrazu
			if(this->Check(i+1, ".") == 1 ||
				this->Check(i+1, "?") == 1 ||
				this->Check(i+1, "!") == 1 ||
				i+1 == m_strLine.GetLength())
			{				
				pTrans->SetLetter("o~");
			}
			// przed p, b
			else if(this->Check(i+1, "p") == 1 || 
				this->Check(i+1, "b") == 1)
			{
				pTrans->SetLetter("om");
			}
			// przed k, g
			else if(this->Check(i+1, "k") == 1 ||
				this->Check(i+1, "g") == 1)
			{
				pTrans->SetLetter("oN");
			}
			// przed l
			else if(this->Check(i+1, "l") == 1)
			{
				pTrans->SetLetter("o");
			}
			// przed 
			else if(this->Check(i+1, CString(char(136))) == 1)
			{
				pTrans->SetLetter("o");
			}
			// przed 
			else if(this->Check(i+1, CString(char(134))) == 1)
			{
				pTrans->SetLetter("on'");
			}
			else if(this->Check(i+1, "c") == 1 )
			{
				// przed ci
				if(this->Check(i+2, "i") == 1)
				{
					pTrans->SetLetter("on'");
				}
				// przed c
				else
				{
					pTrans->SetLetter("on");
				}				
			}
			else if(this->Check(i+1, "d") == 1)
			{
				// przed d
				if(this->Check(i+2, CString(char(171))) == 1)
				{
					pTrans->SetLetter("on'");
				}
				// przed dzi
				else if(this->Check(i+2, "z") == 1 &&
					this->Check(i+3, "i") == 1)
				{
					pTrans->SetLetter("on'");
				}
				// przed d
				else
				{
					pTrans->SetLetter("on");			
				}
			}
			m_trTmp.AddTail((CObject*)pTrans);
			break;
		case 'b':
			// koniec wyrazu, wyglos, przed spolgloska bezdzwieczna
			if (this->Check(i+1, " ") == 1 ||
				i+1 == m_strLine.GetLength() ||
				this->CheckUbez(i+1) == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("p");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
			// koniec wyrazu, wyglos, przed spolgloska bezdzwieczna
		case 'g':
			if(this->Check(i+1, " ") == 1 ||
				i+1 == m_strLine.GetLength() || 
				this->CheckUbez(i+1) == 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("k");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;	
		case 'p':
			// przed spolgloska dzwieczna
			if(this->CheckUdz(i+1) == 1 &&
				i != 0 && this->Check(i-1, " ") != 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("b");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
		case 't':
			// przed spolgloska dzwieczna
			if(this->CheckUdz(i+1) == 1 &&
				i != 0 && this->Check(i-1, " ") != 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("d");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
		case 'k':
			// przed spolgloska dzwieczna
			if(this->CheckUdz(i+1) == 1 &&
				i != 0 && this->Check(i-1, " ") != 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("g");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
		case 'f':
			// przed spolgloska dzwieczna
			if(this->CheckUdz(i+1) == 1 &&
				i != 0 && this->Check(i-1, " ") != 1)
			{
				pTrans = m_trLine.GetLetter(i);
				pTrans->SetLetter("v");
				m_trTmp.AddTail((CObject*)pTrans);
			}
			else
			{
				pTrans = m_trLine.GetLetter(i);
				m_trTmp.AddTail((CObject*)pTrans);
			}
			break;
		default:
			pTrans = m_trLine.GetLetter(i);
			m_trTmp.AddTail((CObject*)pTrans);
			break;
		};
	}	
	m_trLine.RemoveAll();
	for(i=0; i<m_trTmp.GetCount(); i++)
	{
		pTrans = m_trTmp.GetLetter(i);
		m_trLine.AddTail((CObject*)pTrans);
	}
	m_trTmp.RemoveAll();
}

void CSAMPA::Reduction(void)
{
	for(int i=0; i<m_strLine.GetLength(); i++)
	{
		if(m_strLine[i] == 'l')
		{
			if(this->CheckSamogl(i-1) == 0 &&
				this->CheckSamogl(i+1) == 0)
			{
				m_trLine.Remove(i);
				m_strLine.Delete(i, 1);
			}
		}
	}
}

void CSAMPA::Sylaby(CTransList* trWord)
{
	CTrans *pTrans;
	POSITION pos = trWord->GetHeadPosition();
	CTransList trTmp;
	CTransList* trSylaba = new CTransList();
	int nTest = -1;
	int nCount = 0;
	int nCount_2 = 0;
	for(int i=0; i<trWord->GetCount(); i++)
	{
		pTrans = (CTrans*)trWord->GetLetter(i);		
		switch(pTrans->GetLetter()[0])
		{
		case 'a':
		case 'e':
		case 'i':
		case 'I':		
		case 'o':
		case 'u':				
			nCount++;
			break;		
		};		
	}
	for(int i=0; i<trWord->GetCount(); i++)
	{
		pTrans = (CTrans*)trWord->GetLetter(i);		
		switch(pTrans->GetLetter()[0])
		{
		case 'a':
		case 'e':
		case 'i':
		case 'I':		
		case 'o':
		case 'u':	
			trSylaba->AddTail((CObject*)pTrans);
			trTmp.AddTail((CObject*)trSylaba);					
			nCount_2++;
			if(nCount_2 != nCount)
				nTest = 1;			
			break;
		default:
			trSylaba->AddTail((CObject*)pTrans);
			break;
		};		
		if(nTest == 1)
		{
			trSylaba = new CTransList();
			nTest = -1;
		}
	}
	pos = trTmp.GetHeadPosition();
	trWord->RemoveAll();
	while(pos != NULL)
	{
		trSylaba = (CTransList*)trTmp.GetNext(pos);
		trWord->AddTail((CObject*)trSylaba);
	}
	trTmp.RemoveAll();		
}

void CSAMPA::Wyrazy(void)
{
	POSITION pos = m_trLine.GetHeadPosition();
	CTrans* pTrans;
	CTransList* trWord = new CTransList();
	CTransList* trBrake = new CTransList();
	CTransList trTmp;
	int nCount = 0;
	while(pos != NULL)
	{
		pTrans = (CTrans*)m_trLine.GetNext(pos);
		switch(pTrans->GetLetter()[0])
		{
		case char(32):
			break;
		case ',':
			Sylaby(trWord);
			trTmp.AddTail((CObject*)trWord);
			trWord = new CTransList();
			
			trBrake->AddTail((CObject*)new CBrake(' '));
			trWord->AddTail((CObject*)trBrake);
			trTmp.AddTail((CObject*)trWord);
			trWord = new CTransList();
			trBrake = new CTransList();
			break;
		case '.':
		case '?':
		case '!':
			Sylaby(trWord);
			trTmp.AddTail((CObject*)trWord);
			trWord = new CTransList();

			trBrake->AddTail((CObject*)new CBrake('_'));
			trWord->AddTail((CObject*)trBrake);
			trTmp.AddTail((CObject*)trWord);
			trWord = new CTransList();
			trBrake = new CTransList();
			nCount = 0;
			break;
		default:
			trWord->AddTail((CObject*)pTrans);
			break;
		};
		if(nCount == m_trLine.GetCount()-1)
		{
			Sylaby(trWord);
			trTmp.AddTail((CObject*)trWord);
			trWord = new CTransList();
		}
		nCount++;
	}

	pos = trTmp.GetHeadPosition();
	m_trLine.RemoveAll();
	while(pos != NULL)
	{
		trWord = (CTransList*)trTmp.GetNext(pos);
		m_trLine.AddTail((CObject*)trWord);
	}
	trTmp.RemoveAll();
}

void CSAMPA::SetDuration(void)
{
	POSITION pos = m_trLine.GetHeadPosition();
	POSITION pos_2 = NULL;
	CTransList *pWord = new CTransList();
	CTransList *pSylaba = new CTransList();
	CTransList trTmp;
	CTransList *ptrTmpWord = new CTransList;
	CTrans *pTrans;
	while(pos != NULL)
	{
		pWord = (CTransList*)m_trLine.GetNext(pos);		
		pos_2 = pWord->GetHeadPosition();
		while(pos_2 != NULL)
		{
			pSylaba = (CTransList*)pWord->GetNext(pos_2);
			for(int i=0; i<pSylaba->GetCount(); i++)
			{
				pTrans = pSylaba->GetLetter(i);
				switch(pTrans->GetLetter()[0])
				{
				//samogLoski
				case 'i':
				case 'I':
				case 'e':
				case 'a':
				case 'o':
				case 'u':
					pTrans->SetDuration(70);
					pSylaba->InsertAt(i, pTrans);
					break;
				//plozywne
				case 'p':
				case 'b':
				case 't':
				case 'k':
				case 'g':
				case 'd':
					pTrans->SetDuration(60);
					pSylaba->InsertAt(i, pTrans);
					break;
				//nosowe
				case 'm':
				case 'n':
					pTrans->SetDuration(85);
					pSylaba->InsertAt(i, pTrans);
					break;
				//szumowe
				case 'f':
				case 'v':
				case 's':
				case 'S':
				case 'z':
				case 'Z':
				case 'x':
					pTrans->SetDuration(65);
					pSylaba->InsertAt(i, pTrans);
					break;
				};
			}
			ptrTmpWord->AddTail((CObject*)pSylaba);
		}
		trTmp.AddTail((CObject*)ptrTmpWord);
		ptrTmpWord = new CTransList();
	}

	pos = trTmp.GetHeadPosition();
	m_trLine.RemoveAll();
	while(pos != NULL)
	{
		pWord = (CTransList*)trTmp.GetNext(pos);
		m_trLine.AddTail((CObject*)pWord);
	}
	trTmp.RemoveAll();
}

void CSAMPA::SetFrequencyWord(void)
{
	POSITION pos = m_trLine.GetHeadPosition();
	POSITION pos_2 = NULL;
	CTransList *pWord = new CTransList();
	CTransList *pSylaba = new CTransList();
	CTrans* pTrans;
	CTransList trTmp;
	CTransList *ptrWordTmp = new CTransList();
	while(pos != NULL)
	{	
		pWord = (CTransList*)m_trLine.GetNext(pos);
		if(pWord->GetCount() >= 3)
		{				
			pSylaba = pWord->GetSylaba((int)(pWord->GetCount())-2);
			
			pTrans = pSylaba->GetLetter((int)pSylaba->GetCount()-2);
			pTrans->SetFreq(pTrans->GetFreq()+10);
			pSylaba->InsertAt((int)pSylaba->GetCount()-2, pTrans);
			
			pTrans = pSylaba->GetLetter((int)pSylaba->GetCount()-1);
			pTrans->SetFreq(pTrans->GetFreq()+20);
			pSylaba->InsertAt((int)pSylaba->GetCount()-1, pTrans);
			pWord->InsertAt((int)pWord->GetCount()-2, pSylaba);
			
			pSylaba = pWord->GetSylaba((int)pWord->GetCount()-1);

			pTrans = pSylaba->GetLetter(0);
			pTrans->SetFreq(pTrans->GetFreq()+10);
			pSylaba->InsertAt(0, pTrans);
            pWord->InsertAt((int)pWord->GetCount()-1, pSylaba);			
		}
		trTmp.AddTail((CObject*)pWord);
	}

	pos = trTmp.GetHeadPosition();
	m_trLine.RemoveAll();
	while(pos != NULL)
	{
		pWord = (CTransList*)trTmp.GetNext(pos);
		m_trLine.AddTail((CObject*)pWord);
	}
	trTmp.RemoveAll();
}

int CSAMPA::CountSylaby(void)
{
	POSITION pos = m_trLine.GetHeadPosition();
	POSITION pos_2 = NULL;
	CTransList *pWord = new CTransList();
	CTransList *pSylaba = new CTransList();
	int nCount = 0;
	while(pos != NULL)
	{
		pWord = (CTransList*)m_trLine.GetNext(pos);
		nCount += (int)pWord->GetCount();
	}
	return nCount;
}
int CSAMPA::CountLetters(void)
{
	CTransList *pWord = new CTransList();
	CTransList *pSylaba = new CTransList();
	int nCount = 0;
	for(int i=0; i<m_trLine.GetCount(); i++)
	{
		pWord = m_trLine.GetSylaba(i);
		for(int j=0; j<pWord->GetCount(); j++)
		{
			pSylaba = pWord->GetSylaba(j);
			nCount += (int)pSylaba->GetCount();
		}
	}
	return nCount;
}
int CSAMPA::CountLetters(int nSylaba, int nWyraz)
{
	CTransList *pWord = new CTransList();
	CTransList *pSylaba = new CTransList();
	int nCount = 0;
	if(nWyraz < (int)m_trLine.GetCount())
	{
		for(int i=0; i<(int)m_trLine.GetCount()-1; i++)
		{
			pWord = m_trLine.GetSylaba(i);
			if(nSylaba < (int)pWord->GetCount())
			{
				for(int j=nSylaba; j<pWord->GetCount(); j++)
				{
					pSylaba = pWord->GetSylaba(j);
					
					nCount += (int)pSylaba->GetCount();
					
				}
			}
			else
			{
				nCount = -1;
			}	
		}
	}
	else
	{
		nCount = -1;
	}
	return nCount;
}


void CSAMPA::SetFrequencySentence(void)
{
	CTransList *pWord = new CTransList();
	CTransList *pSylaba = new CTransList();
	CTrans *pTrans;
	int nValue = 0;
	int nFreq = 0;
	switch(this->m_strLine[m_strLine.GetLength()-1])
	{
	case '.':		
		if(this->CountSylaby() >= 3)
		{
			pWord = m_trLine.GetSylaba((int)m_trLine.GetCount()-2);
			pSylaba = pWord->GetSylaba((int)pWord->GetCount()-1);		
			pTrans = pSylaba->GetLetter(0);
			nFreq = nValue = pTrans->GetFreq();
			nValue = nValue - 180;
			nValue = nValue/(int)pSylaba->GetCount();

			for(int i=0; i<pSylaba->GetCount(); i++)
			{
			
				pTrans = (CTrans*)pSylaba->GetLetter(i);
				nFreq = nFreq - nValue;
				pTrans->SetFreq(nFreq);
				pSylaba->InsertAt(i, pTrans);								
			}

			pWord->InsertAt((int)pWord->GetCount()-1, pSylaba);
			m_trLine.InsertAt((int)m_trLine.GetCount()-2, pWord);			
		}
		break;
	case '?':
		if(this->CountSylaby() >= 3)
		{
			pWord = m_trLine.GetSylaba(0);
			pSylaba = pWord->GetSylaba(0);
			pTrans = pSylaba->GetLetter((int)pSylaba->GetCount()-1);
			pTrans->SetFreq(pTrans->GetFreq()+30);
			pSylaba->InsertAt((int)pSylaba->GetCount()-1, pTrans);
			pTrans = pSylaba->GetLetter(0);
			int nConstFreq = pTrans->GetFreq();
			nValue = 30/(int)pSylaba->GetCount();
			nFreq = nConstFreq + 30;
			for(int i=0; i<pSylaba->GetCount()-1; i++)
			{
				pTrans = pSylaba->GetLetter(i);
				nFreq = nFreq - nValue;
				pTrans->SetFreq(nFreq);
				pSylaba->InsertAt(i, pTrans);
			}
			pWord->InsertAt(0, pSylaba);
			double nCountLetter = CountLetters(1, 0);
			nCountLetter = nCountLetter*0.4;
			int nCount = 0;
			nFreq = nConstFreq + 30;
			
			nValue = nFreq - nConstFreq;
			nValue = nValue/nCountLetter;
			for(i=0; i<m_trLine.GetCount()-1; i++)
			{
				pWord = m_trLine.GetSylaba(i);
				for(int j=1; j<pWord->GetCount(); j++)
				{
					pSylaba = pWord->GetSylaba(j);					
					for(int k=0; k<pSylaba->GetCount(); k++)
					{						
						pTrans = pSylaba->GetLetter(k);
						nFreq = nFreq - nValue;
						pTrans->SetFreq(nFreq);
						pSylaba->InsertAt(k, pTrans);
						nCount++;
						if(nCount == nCountLetter)
							break;
					}
					pWord->InsertAt(j, pSylaba);
					if(nCount == nCountLetter)
						break;
				}				
				m_trLine.InsertAt(i, pWord);
				if(nCount == nCountLetter)
					break;
			}

		}
		break;
	case '!':
		if(this->CountSylaby() >= 3)
		{
			pWord = m_trLine.GetSylaba(0);
			pSylaba = pWord->GetSylaba(0);
			pTrans = pSylaba->GetLetter((int)pSylaba->GetCount()-1);
			pTrans->SetFreq(250);
			pSylaba->InsertAt((int)pSylaba->GetCount()-1, pTrans);
			pTrans = (CTrans*)pSylaba->GetLetter(0);
			int nConstFreq = pTrans->GetFreq();
			nValue = 250 - nConstFreq;
			nFreq = 250;
			nValue = nValue/(int)pSylaba->GetCount();
			for(int i=0; i<pSylaba->GetCount()-1; i++)
			{
				pTrans = pSylaba->GetLetter(i);
				nFreq = nFreq - nValue;
				pTrans->SetFreq(nFreq);
				pSylaba->InsertAt(i, pTrans);
			}
			pWord->InsertAt(0, pSylaba);
			
			int nCountLetter = CountLetters(1, 0);
			nCountLetter = (int)(nCountLetter*0.4);
			int nCount = 0;
			nFreq = 250;
			
			nValue = 250 - nConstFreq;		
			nValue = nValue/nCountLetter;
			for(i=0; i<m_trLine.GetCount()-1; i++)
			{
				pWord = m_trLine.GetSylaba(i);
				for(int j=1; j<pWord->GetCount(); j++)
				{
					pSylaba = pWord->GetSylaba(j);					
					for(int k=0; k<pSylaba->GetCount(); k++)
					{						
						pTrans = pSylaba->GetLetter(k);
						nFreq = nFreq - nValue;
						pTrans->SetFreq(nFreq);
						pSylaba->InsertAt(k, pTrans);
						nCount++;
						if(nCount == nCountLetter)
							break;
					}
					pWord->InsertAt(j, pSylaba);
					if(nCount == nCountLetter)
						break;
				}				
				m_trLine.InsertAt(i, pWord);
				if(nCount == nCountLetter)
					break;
			}
		}
		break;
	default:
		break;
	};
}
void CSAMPA::DoubleLetters(void)
{
	CTransList *pWord = new CTransList();
	CTransList *pSylaba = new CTransList();
	CTrans *pTrans;
	for(int i=0; i<m_trLine.GetCount(); i++)
	{
		pWord = m_trLine.GetSylaba(i);
		for(int j=0; j<pWord->GetCount(); j++)
		{
			pSylaba = pWord->GetSylaba(j);
			for(int k=0; k<pSylaba->GetCount(); k++)
			{
				pTrans = pSylaba->GetLetter(k);
				if(pTrans->GetLetter() == "em")
				{
					pTrans->SetLetter("e");
					pSylaba->InsertAt(k, pTrans);
					pTrans = new CTrans('m');
					pSylaba->InsertAft(k, pTrans);
				}
				else if(pTrans->GetLetter() == "en")
				{
					pTrans->SetLetter("e");
					pSylaba->InsertAt(k, pTrans);
					pTrans = new CTrans('n');
					pSylaba->InsertAft(k, pTrans);
				}
				else if(pTrans->GetLetter() == "en'")
				{
					pTrans->SetLetter("e");
					pSylaba->InsertAt(k, pTrans);
					pTrans = new CTrans('n');
					pTrans->SetLetter("n'");
                    pSylaba->InsertAft(k, pTrans);
				}
				else if(pTrans->GetLetter() == "eN")
				{
					pTrans->SetLetter("e");
					pSylaba->InsertAt(k, pTrans);
					pTrans = new CTrans('N');
					pSylaba->InsertAft(k, pTrans);
				}
				else if(pTrans->GetLetter() == "om")
				{
					pTrans->SetLetter("m");
					pSylaba->InsertAt(k, pTrans);
					pTrans = new CTrans('m');
					pSylaba->InsertAft(k, pTrans);
				}
				else if(pTrans->GetLetter() == "on")
				{
					pTrans->SetLetter("o");
					pSylaba->InsertAt(k, pTrans);
					pTrans = new CTrans('n');
					pSylaba->InsertAft(k, pTrans);
				}
				else if(pTrans->GetLetter() == "on'")
				{					
					pTrans->SetLetter("e");
					pSylaba->InsertAt(k, pTrans);
					pTrans = new CTrans('n');
					pTrans->SetLetter("n'");
					pSylaba->InsertAft(k, pTrans);
				}
				else if(pTrans->GetLetter() == "oN")
				{
					pTrans->SetLetter("o");
					pSylaba->InsertAt(k, pTrans);
					pTrans = new CTrans('N');
					pSylaba->InsertAft(k, pTrans);
				}
			}
			pWord->InsertAt(j, pSylaba);
		}
		m_trLine.InsertAt(i, pWord);
	}
}

